Attribute VB_Name = "modFileSystemCustom"
Function GetLongFileName(DirectoryPath As String, ShortFileName As String) As String 'kinda good
On Error Resume Next
For v = Len(DirectoryPath) To 1 Step -1
 If Mid(DirectoryPath, v, 1) <> "\" Then Exit For
Next
DirectoryPath = Left(DirectoryPath, v)

For v = 1 To Len(ShortFileName)
 If Mid(ShortFileName, v, 1) = "\" Then
  ShortFileName = Mid(ShortFileName, v + 1)
  v = v - 1
 Else
  Exit For
 End If
Next

GetLongFileName = DirectoryPath & "\" & ShortFileName
End Function

Function GetValidDirectoryName(LongFileName As String, DefaultDirectoryName As String) As String 'good, I think
On Error Resume Next
lastdir = CurDir
For v = Len(LongFileName) To 1 Step -1
 temp$ = Left(LongFileName, v)
 If Mid(LongFileName, v, 1) = "\" Or Mid(LongFileName, v, 1) = ":" Or v = Len(LongFileName) Then
  Err = 0
  ChDir temp$
  If Err = 0 Then
   ChDir lastdir
   GetValidDirectoryName = temp$
   Exit Function
  End If
 End If
Next
ChDir lastdir
GetValidDirectoryName = DefaultDirectoryName
End Function

Function GetShortFileName2(LongFileName As String) As String 'good
On Error Resume Next

For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "." Then
  If v > 1 Then '?:\?????\.ddd, ?:.ddd
   If Mid(LongFileName, v - 1, 1) = "\" Or Mid(LongFileName, v - 1, 1) = ":" Then
    GetShortFileName2 = Mid(LongFileName, v)
    Exit Function
   End If
  Else '.ddd
   GetShortFileName2 = LongFileName
   Exit Function
  End If
 End If
Next

temp$ = LongFileName
If DoesDirectoryExist(temp$ & "\") Then temp$ = temp$ & "\" 'C:\Windows should return blank.
For v = Len(temp$) To 1 Step -1
 If Mid(temp$, v, 1) = "\" Or Mid(temp$, v, 1) = ":" Then
  GetShortFileName2 = Mid(temp$, v + 1)
  Exit Function
 End If
Next

GetShortFileName2 = LongFileName
End Function

Function DoesFileExist(LongFileName As String) As Boolean 'good
On Error Resume Next
freefilenumber = FreeFile
Open LongFileName For Input As freefilenumber
 DoesFileExist = 1 - Sgn(Err)
Close freefilenumber
End Function

'This give only the extension without the dot and wildcard.
Function GetExtensionFromFileName(LongFileName As String, DefaultExtension As String) As String 'good
On Error Resume Next
For v = Len(LongFileName) To 1 Step -1
 If Mid(LongFileName, v, 1) = "\" And lastbackslash = 0 Then lastbackslash = v
 If Mid(LongFileName, v, 1) = "." And lastdot = 0 Then lastdot = v
 If lastdot > lastbackslash Then
  GetExtensionFromFileName = Mid(LongFileName, lastdot + 1)
  Exit Function
 End If
Next

For v = Len(DefaultExtension) To 1 Step -1
 If Mid(DefaultExtension, v, 1) = "." Then
  GetExtensionFromFileName = Mid(DefaultExtension, v + 1)
  Exit Function
 End If
Next

GetExtensionFromFileName = DefaultExtension
End Function

Function DoesDirectoryExist(LongFileName As String) As Boolean 'good
If Trim(LongFileName) = "" Then Exit Function

On Error Resume Next
lastdir = CurDir
ChDir LongFileName
DoesDirectoryExist = 1 - Sgn(Err)
ChDir lastdir
End Function

